<template>
  <main>
    <!-- Header -->
    <div class="row row-xs items-center">
      <div class="col">
        <h1>ARC - Invoice Management</h1>
      </div>
      <div class="col-auto">
        <form @submit.prevent="handleSearch">
          <b-input
            v-model="searchParams.SearchString"
            class="w-max-240"
            placeholder="Search"
            clearable
            @input="handleSearch"
          >
            <b-button-icon
              slot="append"
              native-type="submit"
              primary
              ghost
              name="search"
            />
          </b-input>
        </form>
      </div>
      <div class="col-auto">
        <b-button-group>
          <!-- <b-button-text
            small
            prefix-icon="user-connect"
            @click.prevent="handleAddInvoice"
            >New Invoice</b-button-text
          > -->
          <b-button-text
            v-popover:filterPanel
            small
            prefix-icon="filter"
            :class="{ active: filteringOptionsVisible }"
            @click.prevent="filteringOptionsVisible = !filteringOptionsVisible"
            >Filter</b-button-text
          >
          <b-dropdown
            trigger="click"
            @command="handleSortCommand"
            @visible-change="(value) => (sortPanelVisible = value)"
          >
            <b-button-text
              small
              :prefix-icon="
                (orderBy.order === 'desc' && 'sort-down') ||
                (orderBy.order === 'asc' && 'sort-up') ||
                'sort'
              "
              :class="{ active: sortPanelVisible }"
              @click.capture="filteringOptionsVisible = false"
              >Sort by</b-button-text
            >
            <b-dropdown-menu slot="dropdown" class="w-min-200">
              <b-dropdown-item
                :class="{
                  'c-primary-3': searchParams.OrderBy === 'updatedAt desc',
                }"
                icon="sort-latest-down"
                :command="{ field: 'updatedAt', order: 'desc' }"
              >
                <span class="d-flex items-center">
                  <span>Latest</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Oldest</span>
                </span>
              </b-dropdown-item>
              <b-dropdown-item
                :class="{
                  'c-primary-3': searchParams.OrderBy === 'updatedAt asc',
                }"
                icon="sort-latest-up"
                :command="{ field: 'updatedAt', order: 'asc' }"
              >
                <span class="d-flex items-center">
                  <span>Oldest</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Latest</span>
                </span>
              </b-dropdown-item>
              <b-dropdown-item
                :class="{
                  'c-primary-3': searchParams.OrderBy === 'fullName asc',
                }"
                icon="sort-alphabet-down"
                :command="{ field: 'fullName', order: 'asc' }"
              >
                <span class="d-flex items-center">
                  <span>Ascending</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Descending</span>
                </span>
              </b-dropdown-item>
              <b-dropdown-item
                :class="{
                  'c-primary-3': searchParams.OrderBy === 'fullName desc',
                }"
                icon="sort-alphabet-up"
                :command="{ field: 'fullName', order: 'desc' }"
              >
                <span class="d-flex items-center">
                  <span>Descending</span>
                  <b-icon name="arrow-right" :size="14" class="ml-2x" />
                  <span>Ascending</span>
                </span>
              </b-dropdown-item>
            </b-dropdown-menu>
          </b-dropdown>
        </b-button-group>
      </div>
    </div>
    <b-divider class="mt-6x" />

    <b-popover
      ref="filterPanel"
      v-model="filteringOptionsVisible"
      placement="bottom-end"
      trigger="manual"
      :width="320"
    >
      <b-form-item :label="$t('vuelidate.fields.status')" topless>
        <b-select v-model="searchParams.Status" filterable placeholder="Select">
          <b-option
            v-for="status in statuses"
            :key="status.key"
            :value="status.key"
            :label="status.value"
          />
        </b-select>
      </b-form-item>

      <div class="d-flex content-end mt-6x">
        <b-button @click.prevent="handleFilterCancel">Cancel</b-button>
        <b-button primary class="ml-2x" @click.prevent="handleFilterApply"
          >Apply</b-button
        >
      </div>
    </b-popover>

    <!-- Filtering options -->
    <div v-if="filterParamsTouched()" class="row row-xs items-center mt-6x">
      <div v-if="searchParams.Status !== null" class="col-auto">
        <common-filtered-item
          title="Status"
          @clear="handleClearFilteredParam('Status', null)"
        >
          {{ statuses.find((item) => item.key === searchParams.Status).value }}
        </common-filtered-item>
      </div>
      <div class="col-auto">
        <b-button-text
          small
          prefix-icon="close"
          @click.prevent="handleClearAllFilteredParams"
          >Clear all</b-button-text
        >
      </div>
    </div>

    <!-- Listing -->
    <div v-if="invoices.total > 0">
      <b-card class="mt-6x">
        <div class="row">
          <div
            v-for="(item, index) in invoices.entities"
            :key="item.id + Math.random()"
            class="col-12"
          >
            <div class="row items-center">
              <b-divider v-if="index !== 0" class="mt-3x mb-6x" />
              <div
                v-for="key in Object.keys(item.variables)"
                :key="key"
                class="col"
              >
                <b-form-item :label="key">
                  <b-form-item-text>
                    {{ item.variables[key].value }}
                  </b-form-item-text>
                </b-form-item>
              </div>
              <div class="col-2">
                <b-form-item label="Action">
                  <b-button-group>
                    <b-button-text
                      small
                      prefix-icon="user-connect"
                      @click.prevent="handleApproveInvoice(item)"
                      >Aprove</b-button-text
                    >
                    <b-button-text
                      small
                      prefix-icon="user-connect"
                      @click.prevent="handleRejectInvoice(item)"
                      >Reject</b-button-text
                    >
                    <b-button-text
                      small
                      prefix-icon="user-connect"
                      @click.prevent="handleAuditorInvoice(item)"
                      >Auditor</b-button-text
                    >
                  </b-button-group>
                </b-form-item>
              </div>
            </div>
          </div>
        </div>
      </b-card>
    </div>

    <template v-else>
      <common-empty-state
        v-if="!filterParamsTouched()"
        message="The invoices list is empty."
      />
      <common-search-no-results
        v-else
        title="No result"
        message="These is no records matched your search criteria."
      />
    </template>

    <ApproveInvoiceModal2
      v-if="popupApproveInvoice"
      :entity="itemApprove"
      @submit="handleApproveInvoiceSubmit"
      @close="handleApproveInvoiceClose"
    >
    </ApproveInvoiceModal2>
  </main>
</template>

<script lang="ts">
import Vue from 'vue'
import cloneDeep from 'lodash/cloneDeep'
import ApproveInvoiceModal2 from '~/partials/arc2/ApproveInvoiceModal2.vue'

export default Vue.extend({
  name: 'ARCPage',
  components: {
    ApproveInvoiceModal2,
  },

  data() {
    return {
      searchParams: {
        SearchString: '',
        Status: null as number | null,
        Start: 0,
        Length: 12,
        OrderBy: 'updatedAt desc',
      },
      orderBy: {
        field: 'updatedAt',
        order: 'desc',
      },
      searchDebound: null as any,

      invoices: {
        total: 0,
        entities: [] as any[],
      },

      sortPanelVisible: false,
      filteringOptionsVisible: false,

      statuses: [
        { key: 0, value: 'New' },
        { key: 1, value: 'Approved' },
        { key: 2, value: 'Rejected' },
        { key: 3, value: 'Auditor' },
      ],

      popupApproveInvoice: false,
      itemApprove: null as any,
    }
  },
  head: {
    title: 'Mover',
  },
  meta: {
    breadcrumb: 'Mover',
  },
  computed: {},
  created() {
    this.reloadData()
  },

  methods: {
    filterParamsTouched() {
      return this.searchParams.Status || this.searchParams.Status === 0
    },

    async reloadData(page = 1) {
      this.searchParams.Start = this.searchParams.Length! * (page - 1)

      this.invoices.entities = await this.$services.law.getDataList()
      this.invoices.total = this.invoices.entities.length
    },
    handleSearch() {
      if (this.searchDebound) clearTimeout(this.searchDebound)
      this.searchDebound = setTimeout(() => {
        this.searchParams.SearchString =
          this.searchParams.SearchString?.trim() || ''
        this.reloadData()
      }, 500)
    },
    handleFilterApply() {
      this.filteringOptionsVisible = false
      this.reloadData()
    },
    handleFilterCancel() {
      this.filteringOptionsVisible = false
    },
    handleClearFilteredParam(param: string, initialValue: any = '') {
      Object.assign(this.searchParams, { [param]: initialValue })
      this.reloadData()
    },
    handleClearAllFilteredParams() {
      this.searchParams.Status = null
      this.reloadData()
    },

    handleCurrentPageChange(page: number) {
      this.reloadData(page)
    },
    handleSortCommand(orderBy: { field: string; order: string }) {
      const unsort =
        this.searchParams.OrderBy === `${orderBy.field} ${orderBy.order}`

      this.searchParams.OrderBy = unsort
        ? ''
        : `${orderBy.field} ${orderBy.order}`

      this.orderBy = unsort ? { field: '', order: '' } : cloneDeep(orderBy)

      this.reloadData()
    },

    handleApproveInvoice(item: any) {
      this.itemApprove = item
      this.popupApproveInvoice = true
    },
    handleRejectInvoice(item: any) {
      this.itemApprove = item
      this.popupApproveInvoice = true
    },
    handleAuditorInvoice(item: any) {
      this.itemApprove = item
      this.popupApproveInvoice = true
    },
    handleApproveInvoiceSubmit() {
      this.popupApproveInvoice = false
      this.itemApprove = null
      this.reloadData()
    },
    handleApproveInvoiceClose() {
      this.popupApproveInvoice = false
      this.itemApprove = null
    },
  },
})
</script>
<style>
.button-active {
  background: #e4ffe7;
  color: #006b0f;
}
.button-active:hover {
  background: #e4ffe7;
  color: #006b0f;
}
.button-active:focus {
  background: #e4ffe7;
  color: #006b0f;
}

.button-deactive {
  background: #f5f5f5;
  color: #000000;
}
.button-deactive:hover {
  background: #f5f5f5;
  color: #000000;
}
.button-deactive:focus {
  background: #f5f5f5;
  color: #000000;
}
</style>
